;*********************************************************************	
; includes
;*********************************************************************	

	.incdir	"F:\git\goldmomo_endlos\assembler_files\ucore\"
	.include "include\ucore_ctrl.i"

;*********************************************************************	
; sd header is placed here
;*********************************************************************	

	.include "boot_level_sdHeader.s"

;*********************************************************************
;* start at address 32 here
;*********************************************************************

start	
	;setup irq vector
	
	movei	r0,irq
	nop
	moveih	r0,>irq
	nop
	setssr	r0,2

	;setup video (720x450)
	
	gpci	r7,2		;next 4 + X
	br	setupVideo
	nop			;delay slot
	nop			;delay slot
	nop			;delay slot
	nop			;delay slot
	
	;clear screen
	
	movei	r2,$00	;destination 
	movei	r3,$00
	moveih	r2,$00
	moveih	r3,$f0	;p(0,0) = f000 0000
	
	gpci	r7,2	;next 4 + X
	br	memset
	movei	r1,$33	; count		delay slot	
	movei	r0,$00	; value		delay slot
	moveih	r1,$9e	; count		delay slot
	nop		;		delay slot
	
	;reset PS2 buffer
	
	gpci	r7,2	;next 4 + X
	br	PS2Reset
	nop			;delay slot
	nop			;delay slot
	nop			;delay slot
	nop			;delay slot
	
	;draw header
	
	gpci	r7,2		;next 4 + X
	br	drawTextFormated
	movei	r0,textHeader	;delay slot
	movei	r1,0		;delay slot
	moveih	r0,>textHeader	;delay slot
	movei	r2,0		;delay slot
	
loop	
	
	;process keys
	
	gpci	r7,2		;next 4 + X
	br	PS2Process
	nop			;delay slot
	nop			;delay slot
	nop			;delay slot
	nop			;delay slot
			
	;draw test string
	
	movei	r7,mPSNormalKeys
	nop
	moveih	r7,>mPSNormalKeys
	nop
	
	movei	r6,8	;9v
	addi	r7,8
	nop
	
loopNKeys	

	rqldi	r7,0
	subi	r6,1
	brts	loopNKeys
	ld	r0	;delay slot
	subi	r7,1    ;delay slot
	push	r0      ;delay slot
	nop             ;delay slot
		
	gpci	r7,2		;next 4 + X
	br	drawTextFormated
	movei	r0,testString	;delay slot
	movei	r1,0		;delay slot
	moveih	r0,>testString	;delay slot
	movei	r2,2	
	
	rqpop
	rqpop
	rqpop
	rqpop
	rqpop
	rqpop
	rqpop
	rqpop
	rqpop
	
	;led off
	
	movei	r7,UcRSwichtWLedG
	movei	r6,$0
	moveih	r7,>UcRSwichtWLedG
	nop
	st	r7,r6	
	
	
	;
	
	
	movei	r7,mPSExtendedKeys
	nop
	moveih	r7,>mPSExtendedKeys
	nop	
	movei	r6,8	;9v
	addi	r7,8
	nop
	
loopEKeys	

	rqldi	r7,0
	subi	r6,1
	brts	loopEKeys
	ld	r0	;delay slot
	subi	r7,1    ;delay slot
	push	r0      ;delay slot
	nop             ;delay slot
		
	
	gpci	r7,2		;next 4 + X
	br	drawTextFormated
	movei	r0,testEString	;delay slot
	movei	r1,0		;delay slot
	moveih	r0,>testEString	;delay slot
	movei	r2,3	
	
	rqpop
	rqpop
	rqpop
	rqpop
	rqpop
	rqpop
	rqpop
	rqpop
	rqpop

	;is key test
	
	gpci	r7,2		;next 4 + X
	br	PS2TestKey
	movei	r0,$29		;delay slot
	nop			;delay slot
	nop			;delay slot
	nop			;delay slot
		
	push	r0
	
	gpci	r7,2		;next 4 + X
	br	drawTextFormated
	movei	r0,testKeyString	;delay slot
	movei	r1,0			;delay slot
	moveih	r0,>testKeyString	;delay slot
	movei	r2,4			;delay slot
		
	rqpop
	nop
	nop
	nop
	
	;last key
	
	movei	r4,mLastKey	
	nop
	movei	r4,>mLastKey
	nop
	rqldi	r4,0
	nop
	nop
	ld	r0
	nop
	
	push	r0
	
	gpci	r7,2		;next 4 + X
	br	drawTextFormated
	movei	r0,lastKeyString	;delay slot
	movei	r1,0			;delay slot
	moveih	r0,>lastKeyString	;delay slot
	movei	r2,5	
	
	rqpop
	nop
	nop
	nop
	
	;ascii char
	
	gpci	r7,2		;next 4 + X
	br	PS2KeyToAscii
	nop			;delay slot
	nop			;delay slot
	nop			;delay slot
	nop			;delay slot	
	
	cmpeqi	r0,0
	brts	skipAsciiDisplay
	nop			;delay slot
	nop			;delay slot
	nop			;delay slot
	nop			;delay slot	

	push	r0

	gpci	r7,2		;next 4 + X
	br	drawTextFormated
	movei	r0,asciiCharString	;delay slot
	movei	r1,0			;delay slot
	moveih	r0,>asciiCharString	;delay slot
	movei	r2,6			;delay slot
	
	rqpop
	nop
	nop
	pop	r0
	nop
	
	push	r0

	gpci	r7,2		;next 4 + X
	br	drawTextFormated
	movei	r0,asciiValueString	;delay slot
	movei	r1,0			;delay slot
	moveih	r0,>asciiValueString	;delay slot
	movei	r2,7			;delay slot
	
	rqpop
	nop
	nop
	pop	r0
	nop
	
	;draw text line
	
	movei	r6,textCursorX
	subi	r0,32			;32 lower values are not in font	
	moveih	r6,>textCursorX
	movei	r2,9			;y = 9
	rqldi	r6,0
	nop
	nop
	ld	r1
	
		
	;
	
	gpci	r7,2
	br	drawChar
	nop			;delay slot
	nop			;delay slot
	nop			;delay slot
	nop			;delay slot	
	
	;cursor x + 1
	
	
	addi	r1,1
	movei	r0,0		;
	cmplosi	r1,90
	movets	r1,r1,r0
	nop
	st	r6,r1
	
	

	
skipAsciiDisplay
	
	;led off
	
	movei	r7,UcRSwichtWLedG
	movei	r6,$ff
	moveih	r7,>UcRSwichtWLedG
	nop
	st	r7,r6	
	
	
	;
	
		
	br	loop
	nop			;delay slot
	nop			;delay slot
	nop			;delay slot
	nop			;delay slot	
		
end	
	br	end
	nop			;delay slot
	nop			;delay slot
	nop			;delay slot
	nop			;delay slot
	
	
textCursorX	word	0	

	
	
;***********************************************************************
;* irq code start
;***********************************************************************
	
irq
	cli
	rti
	nop		;delay slot
	nop		;delay slot
	nop		;delay slot
	sei		;delay slot
		
;*********************************************************************
;* functions
;*********************************************************************

	.include	"components\ps2keyboard.s"
	.include	"components\ps2keyboard_layout_de.s"
	.include	"components\ps2keyToAscii.s"
	.include	"components\drawText.s"
	.include	"components\binSearch.s"
	

	
;******************************
;*
;* drawChar
;* 
;* r0 	 	value
;* r1		x 	
;* r2		y
;*
;* trash r0

drawChar	

	push	r1
	push	r2
	push	r3
	push	r4
	push	r5
	push	r6
	push	r7
	
	;destination base (sram base 0)
	
	muli	r1,8
	
	movei	r4,$00	;destination 
	movei	r5,$00
	moveih	r4,$00
	moveih	r5,$f0	;p(0,0) = f000 0000
	
	add	r4,r4,r1
	addtqi	r5,r5,0
	
	movei	r1,$00
	nop
	moveih	r1,$2d	;720*16
	nop
	
	mul	r1,r1,r2;*y
	gmulhi	r2
	
	add	r4,r4,r1
	addt	r5,r5,r2
		
	;font source
	
	movei	r2,$68	;source 
	movei	r3,$01
	moveih	r2,$50
	moveih	r3,$e0	;p(0,0) = e001 5068
	
	muli	r0,8		;value * 8
	nop
	add	r2,r2,r0	;source 
	addtqi	r3,r3,0		;

	;

	movei	r0,15		;16 [y]
dcYloop	
	

	movei	r1,7		;8 [x]
dcXloop
	esadr	r3,r2
	erqldi	0
	eld	r6
	movei	r7,0
	
	extri	r6,15
	movets	r6,r6,r7
		
	esadr	r5,r4
	est	r6,0
	
	subi	r1,1		;x-
	brts	dcXloop
	addi	r4,1		;delay slot
	addtqi	r5,r5,0		;delay slot
	addi	r2,1		;delay slot
	addtqi	r3,r3,0		;delay slot
	
	;
		
	movei	r1,$c8
	nop
	moveih	r1,$2		;r1 = 720-8
	nop
	
	add	r4,r4,r1	;dest + 720-8
	addtqi	r5,r5,0		;
	
	movei	r1,$e8
	nop
	moveih	r1,$2		;r1 = 752-8
	nop	
	
	subi	r0,1		;y-
	brts	dcYloop
	add	r2,r2,r1	;source + 752-8		delay slot
	addtqi	r3,r3,0		;			delay slot
	nop			;delay slot
	nop			;delay slot
	
	;
	
	rqpop
	rqpop
	rqpop
	pop	r7
	pop	r6
	pop	r5
	
	rqpop
	rqpop
	rqpop
	pop	r4
	pop	r3
	pop	r2
	
	
	rqpop
	jmpi	r7,0
	nop		;delay slot
	pop	r1	;delay slot
	nop		;delay slot
	nop		;delay slot

;******************************
;*
;* r0 	 	value
;* r1		count-1 (8 words))
;* r3:r2	dest
;
memset

clearLoop

	esadr	r3,r2
	est	r0,0
	est	r0,1
	est	r0,2
	est	r0,3
	est	r0,4
	est	r0,5
	est	r0,6
	est	r0,7
	subi	r1,1
	brts	clearLoop
	addi	r2,8	;delay slot
	addtqi	r3,r3,0	;delay slot
	nop		;delay slot
	nop		;delay slot
	
	jmpi	r7,0
	nop		;delay slot
	nop		;delay slot
	nop		;delay slot
	nop		;delay slot
	
;******************************
;*
;* setupVideo
;*

setupVideo

	
	movei	r0,videoDefault		;source
	movei	r1,UcTimer2Ctrl		;dest-1
	moveih	r0,>videoDefault
	moveih	r1,>UcTimer2Ctrl			
	movei	r2,26			;27-1
	
setupVideoLoop

	rqldi	r0,0
	addi	r0,1
	addi	r1,1
	ld	r3
	subi	r2,1
	brts	setupVideoLoop
	st	r1,r3	;delay slot
	nop		;delay slot
	nop		;delay slot
	nop		;delay slot
		
	jmpi	r7,0
	nop		;delay slot
	nop		;delay slot
	nop		;delay slot
	nop		;delay slot	
	
;*********************************************************************
;* data
;*********************************************************************
	
videoDefault		;AD NAME					NEW				DEFAULT
	
	word	$0001	;10 VIDEO_ON					1				1 (ON)
	word	$0097	;11 HSYNC (D = 11 .. 0)				152-1				152-1
	word	$017f	;12 HSTART (D = 11 .. 0)			384-1				384-1
	word	$017d	;13 HMEMSTART (D = 11 .. 0)			382-1				382-1
	word	$071f	;14 HSTOP (D = 11 .. 0)				1824-1				1824-1
	word	$076f	;15 HTOTAL (D = 11 .. 0)			1904-1				1904-1
	word	$0002	;16 VSYNC (D = 10 .. 0)				3-1				3-1
	word	$001e	;17 VSTART (D = 10 .. 0)			31-1				31-1
	word	$03a2	;18 VSTOP  (D = 10 .. 0)			931-1				931-1
	word	$03a3	;19 VTOTAL  (D = 10 .. 0)			932-1				932-1
	word	$0000	;1a LC ADDER LOW				$0000				$0000
	word	$0080	;1b LC ADDER HIGH				$0080				$0040	
	word	$0000	;1c LC ADDER LATCH				X				X
	word	$0000	;1d LC START (10 .. 0) Pixeloffset		$0000				$0000	
	word	$0000	;1e						X				X
	word	$0000	;1f						X				X
	word	$0008	;20 HLOADSTART 					8				8
	word	$0170	;21 HLOADSTOP					360+8				180+8
	word	$001e	;22 VLOADSTART 					31-1				31-1
	word	$03a2	;23 VLOADSTOP 					931-1				931-1
	word	$0002	;24 VLOADNEXT					2				4
	word	$0000	;25 MEM_STARTADR_store low			$0000				$0000
	word	$f000	;26 MEM_STARTADR_store high			$f000				$f000
	word	$0000	;27 MEM_LINEOFFSET_store low			$0000				$0000
	word	$0000	;28 MEM_LINEOFFSET_store high			$0000				$0000
	word	$0002	;29 MEM_MODE_store 				2				2 (X1R5G5B5X1R5G5B5)
	word	$0000	;2a LATCH MEM_STARTADR/LINEOFFSET/MODE		X				X
			
textHeader	

	.string	"PS2 text lib test"
	word	0

testString	

	.string	"Normal Keys   %x %x %x %x %x %x %x %x %x"
	word	0
	
testEString	

	.string	"Extended Keys %x %x %x %x %x %x %x %x %x"
	word	0	
	
testKeyString

	.string	"Is test Key %u"
	word	0
	
lastKeyString

	.string	"Last Key %x"
	word	0
	
asciiValueString

	.string	"Ascii value %u    "
	word	0	
	
asciiCharString

	.string	"Ascii char %c"
	word	0	