﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace RAWEdit
{
    public class BufferEntry
    {
        public BufferEntry()
        {
            m_name = "";
            m_data = new byte[0];
        }

        public BufferEntry(string iname,byte []idata)
        {
            m_name = iname;
            m_data = idata;
        }

        public string name
        {
            get { return m_name; }
        }

        public byte[] data
        {
            get { return m_data; }
        }


        string m_name;
        byte[] m_data;
    }


    public class Buffer
    {
        Dictionary<string,BufferEntry> m_bufferEntrys = new Dictionary<string,BufferEntry>();

        public List<BufferEntry> entrys
        {
            get 
            { 
                List<BufferEntry> rEntrys = new List<BufferEntry>();

                foreach(KeyValuePair<string,BufferEntry> sb in m_bufferEntrys)
                {
                    rEntrys.Add(sb.Value);
                }

                return rEntrys; 
            }
        }

        public void add(BufferEntry be)
        {
            m_bufferEntrys.Add(be.name, be);
        }

        public void remove(string name)
        {
            m_bufferEntrys.Remove(name);
        }

        public void remove(BufferEntry be)
        {
            remove(be.name);
        }


        public void clear()
        {
            m_bufferEntrys.Clear();
        }

    }
}
