﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace gfx_convert_library.Store
{
    public class DataStream
    {
        List<byte> m_datas;

        public DataStream()
        {
            m_datas = new List<byte>();
        }

        public void Write(byte b)
        {
            m_datas.Add(b);
        }

        public long Length
        {
            get { return m_datas.Count; }
        }

        public void Write(UInt16 b)
        {
            m_datas.Add((byte)(b >> 8));
            m_datas.Add((byte)(b));
        }

        public void Write(UInt32 b)
        {
            m_datas.Add((byte)(b >> 24));
            m_datas.Add((byte)(b >> 16));
            m_datas.Add((byte)(b >> 8));
            m_datas.Add((byte)(b));
        }

        internal void Read(byte[] buffer, int start, int count)
        {
            for (int i = start; i < (start + count); i++)
            {
                buffer[i] = m_datas[i];
            }
        }

        internal void Read(out byte data, int pos)
        {
            data = 0;
            if (pos < m_datas.Count)
            {
                data = m_datas[pos];
            }
        }

        internal void Read(out UInt16 data, int pos)
        {
            byte a, b;

            Read(out a, pos * 2);
            Read(out b, pos * 2 + 1);

            data = (UInt16)(((UInt16)a) << 8 | ((UInt16)b));

        }

        internal void Read(out UInt32 data, int pos)
        {
            byte a, b, c, d;

            Read(out a, pos * 4);
            Read(out b, pos * 4 + 1);
            Read(out c, pos * 4 + 2);
            Read(out d, pos * 4 + 3);


            data = (UInt32)(((UInt32)a) << 24 | ((UInt32)b) << 16 | ((UInt32)c) << 8 | ((UInt32)d));
        }
    }
}
