﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using xcore_tools.Data;
using xcore_tools;

namespace hcore_assembler_library
{
    public class LineTextReader : TextReader, IPrint
    {
        IPrint m_iprint;
        int m_counter = 0;
        int m_line = 0;

        public List<Line> lines { get; set; }

        public LineTextReader(string fileName,IPrint iprint)
        {              
            lines = new List<Line>();
            uint lineNumber = 1;
            m_iprint = iprint;

            StreamReader file = new StreamReader(fileName);
            for (string s; (s = file.ReadLine()) != null; lineNumber++)
            {
                lines.Add(new Line(s + System.Environment.NewLine, fileName, lineNumber));
            }
            file.Close();

            m_counter = 0;
            m_line = 0;
        }

        public Line currentLine
        {
            get 
            {
                if (m_line >= lines.Count())
                {
                    return new Line("EOF", "EOF", (uint)(m_line-1));
                }
                else
                {
                    return lines[m_line];
                }
            }
        }

        public override int Read()
        {
            if (m_line >= lines.Count())
            {
                return -1;
            }

            Line currentLine = lines[m_line];
            if (m_counter >= currentLine.value.Count())
            {
                m_counter = 0;
                m_line++;
                return Read();
            }
            else
            {   int val = currentLine.value[m_counter++];
              //  print(""+(Char)val);
                return val;
            }
        }

        public void print(string txt)
        {
            m_iprint.print(txt);
        }

        public void dprint(string txt)
        {
            m_iprint.dprint(txt);
        }
    }
}
