﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using xcore_tools;
using xcore_tools.Data;

namespace ucore_assembler_library.IO
{
    class LoadText
    {
        IPrint m_iprint;

        public LoadText(IPrint iprint)
        {
            m_iprint = iprint;
        }

        public bool readFile(string fileName, ref List<Line> data)
        {
            m_iprint.dprint("readFile (" + fileName + ")\n");
            string content;

            try
            {
                using (FileStream fs = File.Open(fileName, FileMode.Open, FileAccess.Read, FileShare.None))
                {
                    byte[] b = new byte[fs.Length];
                    fs.Read(b, 0, b.Length);

                    UTF8Encoding temp = new UTF8Encoding(true);
                    content = temp.GetString(b);
                    fs.Close();
                }
            }
            catch (Exception)
            {
                return false;
            }

            string[] lineDatas = content.Split('\n');

            data.Clear();

            for (uint i = 0; i < lineDatas.Length; i++)
            {
                data.Add(new Line(lineDatas[i], fileName, i + 1));
            }

            return true;
        }
    }
}
