﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using System.Text.RegularExpressions;

namespace ucore_emulator.common
{

    public class performaceInformations
    {
        public void clear()
        {
            fps = currentMips = maxMips = 0.0;
        }

        public double fps;
        public double currentMips;
        public double maxMips;
    };

    public class hiresCounter
    {
        private long m_startTime, m_stopTime;
        private long m_freq;

        // Constructor

        public hiresCounter()
        {
            m_startTime = 0;
            m_stopTime = 0;
            m_freq = Stopwatch.Frequency;
        }

        public void start()
        {
            m_startTime = current();
        }

        public void stop()
        {
            m_stopTime = current();
        }


        public double elapsed()
        {
            return calculate(m_stopTime, m_startTime);
        }

        // special use

        public double calculate(long s1, long s2)
        {
            return (double)(s1 - s2) / (double)frequency();
        }

        public long current()
        {
            return Stopwatch.GetTimestamp(); ;
        }

        public long frequency()
        {
            return m_freq;
        }
    } 
}
