﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ucore_emulator.core.components.stages;

namespace ucore_emulator.core.components
{
    public class ctrl_struct
    {
        public ctrl_struct(uint ihcore_sel, UInt16 iaddress, UInt16 idata)
        {
            hcore_sel = ihcore_sel;
            address = iaddress;
            data = idata;
        }

        public uint hcore_sel; // 8
        public UInt16 address;   // 16
        public UInt16 data;      // 16
    };
		
    public class hcore_ctrl : IStage
    {
        Dictionary<uint, Queue<ctrl_struct>> m_hcore_ctrl_fifo;

        bool m_hcores_reset = true;

        public hcore_ctrl()
        {
            m_hcore_ctrl_fifo = new Dictionary<uint, Queue<ctrl_struct>>();
        }

        public void push(ctrl_struct ctrl)
        {
            if (ctrl.hcore_sel == 0xff)
            {
                m_hcores_reset = (ctrl.data & 1) == 0 ? false : true;
            }
            else
            {
                if (m_hcore_ctrl_fifo.ContainsKey(ctrl.hcore_sel) == false)
                {
                    m_hcore_ctrl_fifo[ctrl.hcore_sel] = new Queue<ctrl_struct>();
                }
                m_hcore_ctrl_fifo[ctrl.hcore_sel].Enqueue(ctrl);
            }
        }

        public bool hasData(uint hcoreNum)
        {
            if (m_hcore_ctrl_fifo.ContainsKey(hcoreNum) == false)
            {
                return false;
            }
            else
            {
                if (m_hcore_ctrl_fifo[hcoreNum].Count == 0)
                {
                    return false;
                }
            }

            return true;
        }

        public ctrl_struct getData(uint hcoreNum)
        {
            if(hasData(hcoreNum))
            {
                return m_hcore_ctrl_fifo[hcoreNum].Dequeue(); 
            }

            throw new Exception("hcore_ctrl::getData(...) has no Data");
        }

        public bool isHCoresReset()
        {
            return m_hcores_reset;
        }

        public void reset()
        {
            m_hcores_reset = true;
            m_hcore_ctrl_fifo.Clear();
        }
    }
}
