﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ucore_emulator.core.components.memory
{
    public class Ucore1MainMemory : IMemIO
    {
        UInt16[] m_mem = null;
        int m_size = 0;
        int m_sizeMask;

        public Ucore1MainMemory(int width = 14)
        {
            m_size = 1 << width;
            m_sizeMask = m_size - 1;

            m_mem = new UInt16[m_size];
        }

        public void write(uint adr, UInt16 value)
        {
            m_mem[adr & m_sizeMask] = value;
        }

        public UInt16 read(uint adr)
        {
           return m_mem[adr & m_sizeMask];
        }

        public int size
        {
            get { return m_size; }
        }
    }
}
