﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ucore_assembler_library;
using xcore_tools;

namespace ucore_emulator.core.components.stages.execute_extensions
{
    public class emulator_special : IPrint, IStage
    {
        IPrint m_iprint;
        public emulator_special(IPrint iprint)
        {
            m_iprint = iprint;
        }

        UInt32 readOnlyStart = 0, readOnlyStop = 0;

        public List<KeyValuePair<UInt32, UInt32>> m_readOnlyMap = new List<KeyValuePair<uint,uint>>();

        public void setData(UInt16 sel, UInt16 data)
        {
            switch (sel)
            {
                case 0: readOnlyStart = (readOnlyStart & 0xffff0000) | ((UInt32)data); break;
                case 1: readOnlyStart = (readOnlyStart & 0x0000ffff) |( ((UInt32)data) << 16); break;
                case 2: readOnlyStop  = (readOnlyStop  & 0xffff0000) | ((UInt32)data); break;
                case 3: readOnlyStop  = (readOnlyStop  & 0x0000ffff) | (((UInt32)data) << 16); break;
                case 4: if ((data & 2) != 0)
                        {
                            m_readOnlyMap.Clear();
                        }
                        if ((data & 1) != 0)
                        {
                            KeyValuePair<UInt32, UInt32> addressSpace = new KeyValuePair<uint,uint>(readOnlyStart,readOnlyStop);
                            m_readOnlyMap.Add(addressSpace);
                        }
                    break;
                default: break;
            }
        }

    
        public void  print(string txt)
        {
 	        m_iprint.print(txt);
        }

        public void  dprint(string txt)
        {
 	        m_iprint.dprint(txt);
        }

        public void reset()
        {
            m_readOnlyMap.Clear();
        }
    }
}
