﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ucore_assembler_library;
using xcore_tools;

namespace ucore_emulator.core.components.stages.execute_extensions
{
    public class l2d : IPrint
    {
        //

        public l2d_s0 s0 = new l2d_s0();
        public l2d_s1 s1 = new l2d_s1();
        public l2d_s2 s2 = new l2d_s2();

        //

        l2d_s0_out_s1_in s0_current = new l2d_s0_out_s1_in();
        l2d_s1_out_s2_in s1_current = new l2d_s1_out_s2_in();
        l2d_s2_out s2_current = new l2d_s2_out();

        l2d_s0_out_s1_in s0_next = new l2d_s0_out_s1_in();
        l2d_s1_out_s2_in s1_next = new l2d_s1_out_s2_in();
        l2d_s2_out s2_next = new l2d_s2_out();

        //

        IPrint m_iprint;

        public l2d(IPrint iprint)
        {
            m_iprint = iprint;
        }

        //

        public UInt32 step(bool inwe, int wsel, UInt16 indata, int rsel, out UInt16 outdata, bool en)
        {

            // setup

            s0.setup(inwe, wsel, indata, rsel, out outdata);

            if (en == true)
            {
                s0.process(out s0_next);
                s1.process(s0, s0_current, out s1_next);
                s2.process(s0, s1_current, out s2_next);
            }

            UInt32 dadr = s2_current.dadr;

            s0_next.copy(ref s0_current);
            s1_next.copy(ref s1_current);
            s2_next.copy(ref s2_current);

            return dadr;
        }

        public void print(string txt)
        {
            m_iprint.print(txt);
        }

        public void dprint(string txt)
        {
            m_iprint.dprint(txt);
        }
    }
}
