﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ucore_emulator.common;
using xcore_tools.Common;

namespace ucore_emulator.core.components.stages
{
    public class s3_readReg : bitExtraction, IStage
    {
        UInt16[] m_regs;

        public s3_readReg(UInt16[] regs)
        {
            m_regs = regs;
            reset();
        }

        public void reset()
        {

        }

        public s3_out_s4_in dataOut
        {
            get { return m_out; }
        }

        s3_out_s4_in m_out = new s3_out_s4_in();

        public void process(s2_out_s3_in din, out s3_out_s4_in dout)
        {
            dout = m_out;

            //
				
			dout.opcode 	= din.decode_opcode;
            dout.debug_pc = din.debug_pc;   // only for debug
												
			dout.reg_data_b	= m_regs[din.decode_rb & 0x7];
			dout.reg_data_a	= m_regs[din.decode_ra & 0x7];

            if (din.decode_imm_a == true)
            {
                dout.reg_data_a = din.decode_imm;	// ext 0 (not signed!)
            }

            dout.simm = din.decode_imm;

            dout.reg_rc = din.decode_rc;
            dout.reg_rc_we = din.decode_rc_we;
        }
    }
}
