﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ucore_emulator.core.components.stages;
using xcore_tools.Common;

namespace ucore_emulator.core.components.stages_hcore
{
    class s2b_decode : bitExtraction, IStage
    {
        public void reset()
        {
            for(int i=0;i<m_offsetEnable.Length;i++)
            {
                m_offsetEnable[i] = false;
            }
        }

        public hc_s2b_out_s3_in dataOut
        {
            get { return m_out; }
        }

        public bool[] m_offsetEnable = new bool[128];

        hc_s2b_out_s3_in m_out = new hc_s2b_out_s3_in();

        internal void process(components.stages_hcore.hc_s2_out_s2b_in din, out components.stages_hcore.hc_s2b_out_s3_in dout, components.stages_hcore.hc_s4_out_s5_in dinExec)
        {
            dout = m_out;

            dout.a_as_reg = din.a_as_reg;
            dout.b_as_reg = din.b_as_reg;
            dout.c_as_reg = din.c_as_reg;
            dout.condition = din.condition;
            dout.opcode = din.opcode;  
            dout.debug_pc = din.debug_pc;
            dout.imm = din.imm;

            dout.ra = din.ra;
            dout.rb = din.rb;
            dout.rc = din.rc;

            if (m_offsetEnable[din.ra] == true)
            {
                dout.ra = din.ra + dinExec.roffset;
            }

            if (m_offsetEnable[din.rb] == true)
            {
                dout.rb = din.rb + dinExec.roffset;
            }

            if (m_offsetEnable[din.rc] == true)
            {
                dout.rc = din.rc + dinExec.roffset;
            }
         
            dout.rc_lock = din.rc_lock;
            dout.rc_we = din.rc_we;

            // store new offset

            if (dinExec.en_roffset_en == true)
            {
                m_offsetEnable[dinExec.en_roffset_num] = dinExec.en_roffset_data;
            }
        }
    
    }
}
