﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ucore_emulator.core.components.stages;
using xcore_tools;

namespace ucore_emulator.core.stages_hcore
{
    class s6_writeReg : IStage, IPrint
    {
        private uint[] m_regs;
        private bool[] m_regLocks;
        IPrint m_iprint;

        public s6_writeReg(IPrint iprint,uint[] regs, bool[] regLocks)
        {
            m_iprint = iprint; 
            m_regs = regs;
            m_regLocks = regLocks;
        }

        public void reset()
        {

        }

        internal void process(components.stages_hcore.hc_s5_out_s6_in din)
        {
            if (din.rc_unlock)
            {
                if (m_regLocks[din.rc & 0x7f] == false)
                {
                    throw new Exception("s5_writeReg: Error, unlock an not locked register??");
                }

          //      print(string.Format("Unlock r{0} at pc {1:X8}\n",din.rc,din.debug_pc));
                m_regLocks[din.rc & 0x7f] = false;
            }

            if (din.rc_we == true)
            {
                m_regs[din.rc & 0x7f] = din.rc_data;
            }
        }

        public void print(string txt)
        {
            m_iprint.print(txt);
        }

        public void dprint(string txt)
        {
            m_iprint.dprint(txt);
        }
    }
}
