﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ucore_emulator.core.components.memory;
using ucore_emulator.core.components.memory.ctrl;
using ucore_emulator.core.components.video;
using ucore_assembler_library;
using xcore_tools;

namespace ucore_emulator.core.components
{
    public class ucore_bus : IClocked, IMemIO
    {
        Ucore1MainMemory m_mainMem;
        CtrlMemory m_ctrlMem;

        public ucore_bus(BoardCtrl boardCtrl,VideoComponent video,IPrint iprint,emulator emulator)
        {
            m_mainMem = new Ucore1MainMemory();
            m_ctrlMem = new CtrlMemory(boardCtrl, video, iprint, emulator);
        }

        public CtrlMemory ctrlMemory
        {
            get { return m_ctrlMem; }
        }

        public Ucore1MainMemory ucore1MainMemory
        {
            get { return m_mainMem; }
        }

        public void setUCore(ucore iucore)
        {
            m_ctrlMem.setUCore(iucore);
        }

        public void setHCores(hcore[] m_hcores)
        {
            m_ctrlMem.setHCores(m_hcores);
        }

        public int size
        {
            get { return m_mainMem.size + m_ctrlMem.size; }
        }
        //

        public void write(uint adr, ushort value)
        {
            if ((adr & 0x8000) == 0)
            {
                m_mainMem.write(adr, value);
            }
            else
            {
                m_ctrlMem.write(adr, value);
            }
        }

        public ushort read(uint adr)
        {
            if( (adr & 0x8000) == 0)
            {
                return m_mainMem.read(adr);
            }
            else
            {
                return m_ctrlMem.read(adr);
            }
        }

        public void reset()
        {
            
        }

        public void step()
        {
            m_ctrlMem.step();
        }
    }
}
