﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace xcore_tools.Data
{
    [Serializable]
    public class Line
    {
        public Line(string ivalue, string ifilename, uint iline)
        {
            value = ivalue;
            filename = ifilename;
            line = iline;
            m_binary = false;
            valid = true;
        }

        public Line(string ifilename, uint iline, UInt16[] bData)
        {
            value = "";
            filename = ifilename;
            line = iline;
            m_binary = true;
            m_bData = bData;
            valid = true;
        }

        public Line()
        {
            value = "";
            filename = "";
            line = 0;
            m_binary = false;
            valid = true;
        }

        public Line(Line source)
        {
            value = source.value;
            filename = source.filename;
            line = source.line;
            valid = true;
        }

        public string printable()
        {
            return string.Format("Line {0} Filename '{1}'", line, filename);
        }

        public string value
        {
            get { return m_value; }
            set { m_value = value; }
        }

        public string filename
        {
            get { return m_filename == null ? "unknown" : m_filename; ; }
            set { m_filename = value; }
        }

        public uint line
        {
            get { return m_line==null?0:m_line; }
            set { m_line = value; }
        }

        public bool binary
        {
            get { return m_binary; }
            set { m_binary = value; }
        }

        public UInt16[] bData
        {
            get { return m_bData; }
            set { m_bData = value; }
        }

        public bool valid
        {
            get;
            set;
        }

        private UInt16[] m_bData;
        private bool m_binary;
        private string m_value;
        private string m_filename;
        private uint m_line;
    }
}
