library ieee;
use work.bus_package.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity hcore_requester is
		port 
		(
				-- 
				
				clk				: in std_logic;
				reset				: in std_logic;
				
				--
				
				request 			: in std_logic;
				address 			: in std_logic_vector(31 downto 0);
				data				: in std_logic_vector(31 downto 0);
				mode				: in std_logic;
				iswe				: in std_logic;
				
				ready				: out std_logic;
				
				-- send port
				
				data_send_data		: out std_logic_vector(31 downto 0);
				data_send_address	: out std_logic_vector(31 downto 0);
				data_send_we		: out std_logic;
				data_send_mode		: out std_logic;
				data_send_busy		: in std_logic;
				data_send_wrreq	: out std_logic
				
	
		);
end entity;

architecture rtl of hcore_requester is
begin
	
	ready <= not data_send_busy;
	
	data_send_data 		<= data;
	data_send_address		<= address;
	data_send_we			<= iswe;
	data_send_mode			<= mode;
	
	data_send_wrreq		<= request;
	
end rtl;
