library ieee;
use work.hcore_package.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity divs is
		port 
		(
				-- global

				clk				: in std_logic;
				reset				: in std_logic;
				stall				: in std_logic;
				
				-- 
				
				a					: in std_logic_vector(31 downto 0);	
				b					: in std_logic_vector(31 downto 0);	
				res				: out std_logic_vector(31 downto 0);
				reminder			: out std_logic_vector(31 downto 0)		
			
		);
end entity;

architecture rtl of divs is

procedure udiv_step(
							divisor			: in std_logic_vector;	
							divident			: in std_logic_vector;	
							rest_in 			: in std_logic_vector; 
							qoutient_in 	: in std_logic_vector;
							rest_out			: out std_logic_vector;
							qoutient_out	: out std_logic_vector;
							counter			: in integer	) is 

		
		variable udiv_temp 	: std_logic_vector(31 downto 0);	
	
	begin
		
			qoutient_out := qoutient_in;
		
			udiv_temp := rest_in(30 downto 0) & divident(counter);
			if udiv_temp >= divisor then
				udiv_temp := udiv_temp - divisor;
				qoutient_out(counter) := '1';
			end if;
			rest_out := udiv_temp;
			
			
	end procedure;

		type buffer_t is array(31 downto 0) of std_logic_vector(31 downto 0);	
		
		signal r 	: buffer_t;	
		signal q 	: buffer_t;
		signal ib 	: buffer_t;
		signal ia 	: buffer_t;
		
begin

	process(clk)	
	
		variable vr0 : std_logic_vector(31 downto 0);	
		variable vq0 : std_logic_vector(31 downto 0);	
		--variable vr1 : std_logic_vector(31 downto 0);	
		--variable vq1 : std_logic_vector(31 downto 0);	

		
		
	begin
		if rising_edge(clk) then
			
			if stall = '0' then
			
				vr0 := (others => '0');
				vq0 := (others => '0');
				
				-- 31 
				
				udiv_step(b,a,vr0,vq0,vr0,vq0,31);
				r(31) <= vr0; 
				q(31) <= vq0;
				ib(31) <= b;
				ia(31) <= a;
				
				for i in 31 downto 1 loop
				
					udiv_step(ib(i),ia(i),r(i),q(i),vr0,vq0,i-1);
					
					r(i-1) <= vr0; 
					q(i-1) <= vq0;
					ib(i-1) <= ib(i);
					ia(i-1) <= ia(i);
							
				end loop;
				
			end if;
			
			
			-- 31,30
			
--			udiv_step(b,a,vr0,vq0,vr0,vq0,31);
--			udiv_step(b,a,vr0,vq0,vr1,vq1,30);
--			
--			r(15) <= vr1; 
--			q(15) <= vq1;
--			ib(15) <= b;
--			ia(15) <= a;
--			
----			-- 29,28
----			
----			udiv_step(ib(15),ia(15),r(15),q(15),vr0,vq0,29);
----			udiv_step(ib(15),ia(15),vr0,vq0,vr1,vq1,28);
----			
----			r(14) <= vr1; 
----			q(14) <= vq1;
----			ib(14) <= ib(15);
----			ia(14) <= ia(15);
--			
--			for i in 15 downto 1 loop
--			
--				udiv_step(ib(i),ia(i),r(i),q(i),vr0,vq0,2*i-1);
--				udiv_step(ib(i),ia(i),vr0,vq0,vr1,vq1,2*i-2);
--			
--				r(i-1) <= vr1; 
--				q(i-1) <= vq1;
--				ib(i-1) <= ib(i);
--				ia(i-1) <= ia(i);
--						
--			end loop;
			
			--
		
		end if;
	
	
	end process;
	
	res <= q(0);
	reminder <= r(0);

end rtl;
