library ieee;
use work.hcore_package.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity mul is
		port 
		(
				-- global

				clk				: in std_logic;
				reset				: in std_logic;
				stall 			: in std_logic;
				
				-- 
				
				a					: in std_logic_vector(31 downto 0);	
				b					: in std_logic_vector(31 downto 0);	
				res				: out std_logic_vector(63 downto 0)	
			
		);
end entity;



architecture rtl of mul is

	signal t1 : std_logic_vector(31 downto 0) := (others => '0');
	signal t2 : std_logic_vector(31 downto 0) := (others => '0');
	signal t3 : std_logic_vector(31 downto 0) := (others => '0');
	signal t4 : std_logic_vector(31 downto 0) := (others => '0');
	
begin

	process(clk)
	begin
		if rising_edge(clk) then
			
			if stall = '0' and reset = '0' then 
				t1 <= a(15 downto 0) * b(15 downto 0); 
				t2 <= a(15 downto 0) * b(31 downto 16);
				t3 <= a(31 downto 16) * b(15 downto 0); 
				t4 <= a(31 downto 16) * b(31 downto 16); 
				
				res <= t1 + (t2(15 downto 0) & x"0000") + (t3(15 downto 0) & x"0000") + (t4 & x"00000000");
			end if;
			
		end if;
	end process;
	
	
	
end rtl;
