library ieee;
use work.ucore_package.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity i2c_port is
		port 
		(
				-- global

				clk				: in std_logic;
				reset				: in std_logic;
				
				-- ext
				
				I2C_SCLK			: out std_logic;
				I2C_SDAT			: inout std_logic;
				
				-- internal
				
				clk_in			: in std_logic;
				direction_in	: in std_logic;
				data_write		: in std_logic;
				data_read		: out std_logic															
		);
end entity;



architecture rtl of i2c_port is
begin
	
	-- i2c
	
	process(clk)
	begin 
		if rising_edge(clk) then
			if reset = '1' then
				I2C_SCLK 	<= '1';
				I2C_SDAT 	<= 'Z';
				data_read	<= '0';
			else
				I2C_SCLK <= clk_in;
				
				if direction_in = '0' then -- in
					I2C_SDAT <= 'Z';
				else
					I2C_SDAT <= data_write;
				end if;
				
				data_read <= I2C_SDAT;
			end if;
		end if;
	end process;
	
end rtl;
