library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity sdCtrl_crc7t is
		port 
		(
				-- global

				clk				: in std_logic;
				reset				: in std_logic;	

				--  
				
				dclr				: in std_logic;
				din				: in std_logic;
				din_en			: in std_logic;
				dout 				: out std_logic_vector(6 downto 0)

		);
end entity;

architecture rtl of sdCtrl_crc7t is

signal crc_data : std_logic_vector(6 downto 0) := (others =>'0');	

begin

	--
	
	dout <= crc_data;
	
	-- calc

	process(clk)
	begin
		if rising_edge(clk) then
			if reset = '1' or dclr = '1' then
				crc_data <= (others =>'0');
			else
				if din_en = '1' then
					crc_data(0) <= din XOR crc_data(6); 
					crc_data(1) <= crc_data(0); 
					crc_data(2) <= crc_data(1); 
					crc_data(3) <= din XOR crc_data(2) XOR crc_data(6); 
					crc_data(4) <= crc_data(3); 
					crc_data(5) <= crc_data(4); 
					crc_data(6) <= crc_data(5); 
				end if;
			end if;
		end if;
	end process;

end rtl;
