library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

package ucore_package is

constant eld_u_l 		: integer range 0 to 15 := 0;
constant eld_u_h 		: integer range 0 to 15 := 1;
constant eld_du_l		: integer range 0 to 15 := 2;			
constant eld_du_h		: integer range 0 to 15 := 3;					
constant eld_v_l		: integer range 0 to 15 := 4;		
constant eld_v_h		: integer range 0 to 15 := 5;				
constant eld_dv_l		: integer range 0 to 15 := 6;	
constant eld_dv_h		: integer range 0 to 15 := 7;		
constant eld_xmask	: integer range 0 to 15 := 8;	
constant eld_ymask	: integer range 0 to 15 := 9;			
constant eld_xwidth	: integer range 0 to 15 := 10;			 
constant eld_sadr_l	: integer range 0 to 15 := 11;
constant eld_sadr_h	: integer range 0 to 15 := 12;


type opcode_t is 
( 
	ope_movei,
	ope_moveih,
	ope_addi,
	ope_subi,
	ope_lsri,
	ope_asri,
	ope_muli,
	ope_cmpeqi,
	ope_cmploi,
	ope_cmplosi,
	ope_gpci,
	ope_jmpi,
	ope_extri,
	ope_add,
	ope_sub,
	ope_lsr,
	ope_asr,
	ope_mul,
	ope_cmpeq,
	ope_cmplo,
	ope_cmplos,
	ope_movets,
	ope_and,
	ope_or,
	ope_xor,
	ope_bic,
	ope_addqi,
	ope_subqi,
	ope_lsrqi,
	ope_asrqi,
	ope_mulqi,
	ope_addtqi,
	ope_subtqi,
	ope_edrqldi,
	ope_ld_pop,
	ope_poparqp,
	ope_st,
	ope_stinc,
	ope_bffo,
	ope_bset,
	ope_bclr,
	ope_cmple,
	ope_cmples,
	ope_extb,
	ope_stwo,
	ope_andts,
	ope_orts,
	ope_xorts,
	ope_bicts,
	ope_lsrts,
	ope_asrts,
	ope_ssto,
	ope_udivinit,	
	ope_mults,
	ope_mulsts,
	ope_swp,
	ope_swptc,
	ope_push,
	ope_rqldi,
	ope_rqld,
	ope_br,
	ope_brts,
	ope_brtc,
	ope_rqpop,
	ope_cli,
	ope_sei,
	ope_rti,
	ope_nop,
	ope_addt,
	ope_subt,
	ope_illegal,
	ope_gmulhi,
	ope_espage,
	ope_eld,
	ope_est,
	ope_erqldi,
	ope_epushsadrl,
	ope_epushsadrh,
	ope_epopsadrl,
	ope_epopsadrh,
	ope_estts,	
	ope_getssr,
	ope_setssr,
	ope_getsp,
	ope_setsp,
	ope_tnt,
	ope_vtt,
	ope_udivgq,
	ope_udivgr,
	ope_udivgqh,
	ope_udivgrh,
	ope_udivsdd,
	ope_udivsdv,
	ope_udivsddh,
	ope_udivsdvh,
	ope_udivstep,
	ope_erqld,
	ope_erqldb,
	ope_jmpts,
	ope_jmptc,
	ope_muls,
	ope_neg,
	ope_negts,
	ope_exl2den,
	ope_exl2denerqld,
	ope_exl2derqld
);

--attribute enum_encoding : string;
--attribute enum_encoding of opcode_t : type is "onehot"; -- one hot for better performance

end ucore_package;
